%VG11 uloha 3 (Transformace mezi systmy}
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky

%tic;%stopky

%=============================+
vg11_3_050 % vstupni soubor   |
%=============================+



fid = fopen('3.txt','w'); %vytvoreni *.txt souboru pro vystup


ro = 180/pi;

fprintf(fid,'VG11 - uloha 3\n');
fprintf(fid,'--------------\n\n');

FIX_name = [
    'FIX1'
    'FIX2'
    'FIX3'
    'FIX4'
    'FIX5'
];

USR_name = [
    'USR1'
    'USR2'
];

%vytvoren Vecu jmen meren (z)
for i=1:16
    if(dXYZ(i,1) == 1)
        name = 'FIX1';
    elseif(dXYZ(i,1) == 2)
        name = 'FIX2';
    elseif(dXYZ(i,1) == 3)
        name = 'FIX3';
    elseif(dXYZ(i,1) == 4)
        name = 'FIX4';
    elseif(dXYZ(i,1) == 5)
        name = 'FIX5';
    elseif(dXYZ(i,1) == 4001)
        name = 'USR1';
    elseif(dXYZ(i,1) == 4002)
        name = 'USR2';
    else
        name = '????';
    end

    dXYZ_name_z(i,:) = name;

end

%vytvoren Vecu jmen meren (do)
for i=1:16
    if(dXYZ(i,2) == 1)
        name = 'FIX1';
    elseif(dXYZ(i,2) == 2)
        name = 'FIX2';
    elseif(dXYZ(i,2) == 3)
        name = 'FIX3';
    elseif(dXYZ(i,2) == 4)
        name = 'FIX4';
    elseif(dXYZ(i,2) == 5)
        name = 'FIX5';
    elseif(dXYZ(i,2) == 4001)
        name = 'USR1';
    elseif(dXYZ(i,2) == 4002)
        name = 'USR2';
    else
        name = '????';
    end

    dXYZ_name_do(i,:) = name;

end







FIX_JTSK = FixJTSK(:,1:4);

%PREVOD ZADANYCH BODU ...

fprintf(fid,'Zadan body\n');
fprintf(fid,'=================================\n');
fprintf(fid,'S-JTSK\n');
fprintf(fid,'----------------------------------------------------------\n');
fprintf(fid,'  bod        X [m]         Y [m]      H [m] (elipsoidicka)\n');
fprintf(fid,'----------------------------------------------------------\n');
for i=1:5
    fprintf(fid,'  FIX%.f   %11.4f   %11.4f   %4.4f\n',FIX_JTSK(i,:));
end


%prevod JTSK na zemepisne
fprintf(fid,'----------------------------------------------------------\n');
fprintf(fid,'zemepisn souradnice na Besselove elipsoidu\n');
fprintf(fid,'-----------------------------------------------------------------------------\n');
fprintf(fid,'  bod            fi                     lamda                H (elipsoidicka)\n');
fprintf(fid,'-----------------------------------------------------------------------------\n');

for i=1:5
    [f,l] = JTSK2fl(FixJTSK(i,3),FixJTSK(i,2));
    FIX_fl(i,1) = FIX_JTSK(i,1); %cislo
    FIX_fl(i,2) = f;             %fi
    FIX_fl(i,3) = l;             %lamda
    FIX_fl(i,4) = FIX_JTSK(i,4); %vyska (elipsoidicka)

    fprintf(fid,'  FIX%.f \t %4.f %2.f'' %8.5f'''' \t %4.f %2.f'' %8.5f'''' \t %4.4f\n',FIX_JTSK(i,1),dms2mat(deg2dms(f)),dms2mat(deg2dms(l)),FIX_JTSK(i,4));
end


%prevod zemepisne na kartezske
fprintf(fid,'-----------------------------------------------------------------------------\n');
fprintf(fid,'kartezsk souradnice na Besselove elipsoidu (WGS-84 )\n');
fprintf(fid,'---------------------------------------------------------\n');
fprintf(fid,'  bod        X [m]          Y [m]          Z [m]\n');
fprintf(fid,'---------------------------------------------------------\n');

for i=1:5
    [X,Y,Z] = flH2XYZ(FIX_fl(i,2),FIX_fl(i,3),FIX_fl(i,4),1);
    FIX_WGS(i,1) = FIX_fl(i,1); %cislo
    FIX_WGS(i,2) = X;           %X
    FIX_WGS(i,3) = Y;           %Y
    FIX_WGS(i,4) = Z;           %Z

    fprintf(fid,'  FIX%.f   %11.4f   %11.4f   %4.4f\n',FIX_fl(i,1),X,Y,Z);
end




%VYROVNANI SITE ...

fprintf(fid,'\n\n\nMerene vektory (dX, dY, dZ) v systemu WGS-84\n');
fprintf(fid,'=============================================================\n');
fprintf(fid,'  bod1    bod2         dX [m]         dY [m]         dZ [m]\n');
fprintf(fid,'-------------------------------------------------------------\n');
for i=1:16
    fprintf(fid,'  %s    %s \t %10.4f \t %10.4f \t %10.4f\n',dXYZ_name_z(i,:),dXYZ_name_do(i,:),dXYZ(i,3:5));
end



%priblizne souradnice USR 1 a 2
USR1X = FIX_WGS(1,2) + dXYZ(6,3);
USR1Y = FIX_WGS(1,3) + dXYZ(6,4);
USR1Z = FIX_WGS(1,4) + dXYZ(6,5);

USR2X = FIX_WGS(1,2) + dXYZ(7,3);
USR2Y = FIX_WGS(1,3) + dXYZ(7,4);
USR2Z = FIX_WGS(1,4) + dXYZ(7,5);



%Mat A
A = [
%    FIX 2        FIX 3        FIX 4         FIX 5        USR 1       USR 2
%dx
    1  0  0      0  0  0      0  0  0      0  0  0      0  0  0      0  0  0
    -1 0  0      1  0  0      0  0  0      0  0  0      0  0  0      0  0  0
    0  0  0      -1 0  0      1  0  0      0  0  0      0  0  0      0  0  0
    0  0  0      0  0  0      -1 0  0      1  0  0      0  0  0      0  0  0
    0  0  0      0  0  0      0  0  0      -1 0  0      0  0  0      0  0  0

    0  0  0      0  0  0      0  0  0      0  0  0      1  0  0      0  0  0
    0  0  0      0  0  0      0  0  0      0  0  0      0  0  0      1  0  0
    -1 0  0      0  0  0      0  0  0      0  0  0      1  0  0      0  0  0
    -1 0  0      0  0  0      0  0  0      0  0  0      0  0  0      1  0  0
    0  0  0      -1 0  0      0  0  0      0  0  0      1  0  0      0  0  0
    0  0  0      -1 0  0      0  0  0      0  0  0      0  0  0      1  0  0
    0  0  0      0  0  0      -1 0  0      0  0  0      1  0  0      0  0  0
    0  0  0      0  0  0      -1 0  0      0  0  0      0  0  0      1  0  0
    0  0  0      0  0  0      0  0  0      -1 0  0      1  0  0      0  0  0
    0  0  0      0  0  0      0  0  0      -1 0  0      0  0  0      1  0  0
    0  0  0      0  0  0      0  0  0      0  0  0      -1 0  0      1  0  0
%dy
    0  1  0      0  0  0      0  0  0      0  0  0      0  0  0      0  0  0
    0  -1 0      0  1  0      0  0  0      0  0  0      0  0  0      0  0  0
    0  0  0      0  -1 0      0  1  0      0  0  0      0  0  0      0  0  0
    0  0  0      0  0  0      0  -1 0      0  1  0      0  0  0      0  0  0
    0  0  0      0  0  0      0  0  0      0  -1 0      0  0  0      0  0  0

    0  0  0      0  0  0      0  0  0      0  0  0      0  1  0      0  0  0
    0  0  0      0  0  0      0  0  0      0  0  0      0  0  0      0  1  0
    0  -1 0      0  0  0      0  0  0      0  0  0      0  1  0      0  0  0
    0  -1 0      0  0  0      0  0  0      0  0  0      0  0  0      0  1  0
    0  0  0      0  -1 0      0  0  0      0  0  0      0  1  0      0  0  0
    0  0  0      0  -1 0      0  0  0      0  0  0      0  0  0      0  1  0
    0  0  0      0  0  0      0  -1 0      0  0  0      0  1  0      0  0  0
    0  0  0      0  0  0      0  -1 0      0  0  0      0  0  0      0  1  0
    0  0  0      0  0  0      0  0  0      0  -1 0      0  1  0      0  0  0
    0  0  0      0  0  0      0  0  0      0  -1 0      0  0  0      0  1  0
    0  0  0      0  0  0      0  0  0      0  0  0      0  -1 0      0  1  0

%dz
    0  0  1      0  0  0      0  0  0      0  0  0      0  0  0      0  0  0
    0  0  -1     0  0  1      0  0  0      0  0  0      0  0  0      0  0  0
    0  0  0      0  0  -1     0  0  1      0  0  0      0  0  0      0  0  0
    0  0  0      0  0  0      0  0  -1     0  0  1      0  0  0      0  0  0
    0  0  0      0  0  0      0  0  0      0  0  -1     0  0  0      0  0  0

    0  0  0      0  0  0      0  0  0      0  0  0      0  0  1      0  0  0
    0  0  0      0  0  0      0  0  0      0  0  0      0  0  0      0  0  1
    0  0  -1     0  0  0      0  0  0      0  0  0      0  0  1      0  0  0
    0  0  -1     0  0  0      0  0  0      0  0  0      0  0  0      0  0  1
    0  0  0      0  0  -1     0  0  0      0  0  0      0  0  1      0  0  0
    0  0  0      0  0  -1     0  0  0      0  0  0      0  0  0      0  0  1
    0  0  0      0  0  0      0  0  -1     0  0  0      0  0  1      0  0  0
    0  0  0      0  0  0      0  0  -1     0  0  0      0  0  0      0  0  1
    0  0  0      0  0  0      0  0  0      0  0  -1     0  0  1      0  0  0
    0  0  0      0  0  0      0  0  0      0  0  -1     0  0  0      0  0  1
    0  0  0      0  0  0      0  0  0      0  0  0      0  0  -1     0  0  1
];

%Vec l (mereni)
lmer = [
    dXYZ(:,3)
    dXYZ(:,4)
    dXYZ(:,5)
];

%Vec l (ze souradnic)

x = 1;
y = 2;
z = 3;

FIX = FIX_WGS(:,2:4);

%FIX_pribl = FIX_WGS(:,2:4);

FIX_pribl = [
    FIX_WGS(1,2)                                                  FIX_WGS(1,3)                                                  FIX_WGS(1,4)
    FIX_WGS(1,2) + dXYZ(1,3)                                     ,FIX_WGS(1,3) + dXYZ(1,4)                                     ,FIX_WGS(1,4) + dXYZ(1,5)
    FIX_WGS(1,2) + dXYZ(1,3) + dXYZ(2,3)                         ,FIX_WGS(1,3) + dXYZ(1,4) + dXYZ(2,4)                         ,FIX_WGS(1,4) + dXYZ(1,5) + dXYZ(2,5)
    FIX_WGS(1,2) + dXYZ(1,3) + dXYZ(2,3) + dXYZ(3,3)             ,FIX_WGS(1,3) + dXYZ(1,4) + dXYZ(2,4) + dXYZ(3,4)             ,FIX_WGS(1,4) + dXYZ(1,5) + dXYZ(2,5) + dXYZ(3,5)
    FIX_WGS(1,2) + dXYZ(1,3) + dXYZ(2,3) + dXYZ(3,3) + dXYZ(4,3) ,FIX_WGS(1,3) + dXYZ(1,4) + dXYZ(2,4) + dXYZ(3,4) + dXYZ(4,4) ,FIX_WGS(1,4) + dXYZ(1,5) + dXYZ(2,5) + dXYZ(3,5) + dXYZ(4,5)
];

USR_pribl = [
    USR1X USR1Y USR1Z
    USR2X USR2Y USR2Z
];


lsour = [
FIX_pribl(2,x)-FIX_pribl(1,x)
FIX_pribl(3,x)-FIX_pribl(2,x)
FIX_pribl(4,x)-FIX_pribl(3,x)
FIX_pribl(5,x)-FIX_pribl(4,x)
FIX_pribl(1,x)-FIX_pribl(5,x)
USR_pribl(1,x)-FIX_pribl(1,x)
USR_pribl(2,x)-FIX_pribl(1,x)
USR_pribl(1,x)-FIX_pribl(2,x)
USR_pribl(2,x)-FIX_pribl(2,x)
USR_pribl(1,x)-FIX_pribl(3,x)
USR_pribl(2,x)-FIX_pribl(3,x)
USR_pribl(1,x)-FIX_pribl(4,x)
USR_pribl(2,x)-FIX_pribl(4,x)
USR_pribl(1,x)-FIX_pribl(5,x)
USR_pribl(2,x)-FIX_pribl(5,x)
USR_pribl(2,x)-USR_pribl(1,x)

FIX_pribl(2,y)-FIX_pribl(1,y)
FIX_pribl(3,y)-FIX_pribl(2,y)
FIX_pribl(4,y)-FIX_pribl(3,y)
FIX_pribl(5,y)-FIX_pribl(4,y)
FIX_pribl(1,y)-FIX_pribl(5,y)
USR_pribl(1,y)-FIX_pribl(1,y)
USR_pribl(2,y)-FIX_pribl(1,y)
USR_pribl(1,y)-FIX_pribl(2,y)
USR_pribl(2,y)-FIX_pribl(2,y)
USR_pribl(1,y)-FIX_pribl(3,y)
USR_pribl(2,y)-FIX_pribl(3,y)
USR_pribl(1,y)-FIX_pribl(4,y)
USR_pribl(2,y)-FIX_pribl(4,y)
USR_pribl(1,y)-FIX_pribl(5,y)
USR_pribl(2,y)-FIX_pribl(5,y)
USR_pribl(2,y)-USR_pribl(1,y)

FIX_pribl(2,z)-FIX_pribl(1,z)
FIX_pribl(3,z)-FIX_pribl(2,z)
FIX_pribl(4,z)-FIX_pribl(3,z)
FIX_pribl(5,z)-FIX_pribl(4,z)
FIX_pribl(1,z)-FIX_pribl(5,z)
USR_pribl(1,z)-FIX_pribl(1,z)
USR_pribl(2,z)-FIX_pribl(1,z)
USR_pribl(1,z)-FIX_pribl(2,z)
USR_pribl(2,z)-FIX_pribl(2,z)
USR_pribl(1,z)-FIX_pribl(3,z)
USR_pribl(2,z)-FIX_pribl(3,z)
USR_pribl(1,z)-FIX_pribl(4,z)
USR_pribl(2,z)-FIX_pribl(4,z)
USR_pribl(1,z)-FIX_pribl(5,z)
USR_pribl(2,z)-FIX_pribl(5,z)
USR_pribl(2,z)-USR_pribl(1,z)
];

%Vec l (redukovan meren)
l = lmer - lsour;

%vyrovnn
N = A'*A;
dx = inv(N) * A' * l;
v = A*dx-l;

Mat_v = reshape(v,16,3);


%opravy
fprintf(fid,'-------------------------------------------------------------\n');
fprintf(fid,'opravy merenych vektoru\n');
fprintf(fid,'-------------------------------------------------------------\n');
for i=1:16
    fprintf(fid,'  %s    %s \t %10.4f \t %10.4f \t %10.4f\n',dXYZ_name_z(i,:),dXYZ_name_do(i,:),Mat_v(i,:));
end

lvyr = lmer + v;
Mat_lvyr = reshape(lvyr,16,3);
%vyrovnan meren
fprintf(fid,'-------------------------------------------------------------\n');
fprintf(fid,'vyrovnan vektory\n');
fprintf(fid,'-------------------------------------------------------------\n');
for i=1:16
    fprintf(fid,'  %s    %s \t %10.4f \t %10.4f \t %10.4f\n',dXYZ_name_z(i,:),dXYZ_name_do(i,:),Mat_lvyr(i,:));
end



%stredn chyby

%stredn chyba jednotkov
m0 = ((v'*v)/30)^0.5;

%str.ch.neznmch
mx = m0 * diag(inv(N)).^0.5;

%str.ch.zpr
ml = m0 * diag(A*inv(N)*A').^0.5;

Mat_ml = reshape(ml,16,3);
%vyrovnan meren
fprintf(fid,'-------------------------------------------------------------\n');
fprintf(fid,'stredn chyby vyrovnanch vektoru\n');
fprintf(fid,'-------------------------------------------------------------\n');
for i=1:16
    fprintf(fid,'  %s    %s \t %10.4f \t %10.4f \t %10.4f\n',dXYZ_name_z(i,:),dXYZ_name_do(i,:),Mat_ml(i,:));
end











fprintf(fid,'\n\n\n========================================================\n');
fprintf(fid,'Vyrovnan body (Bessel I)\n');
fprintf(fid,'--------------------------------------------------------\n');
fprintf(fid,'  bod        X [m]          Y [m]          Z [m]\n');
fprintf(fid,'-------------------------------------------------------\n');

Mat_dx = reshape(dx,3,6)';

Mat_dx = [%pridn rdku s nulovmi opravami na pozici FIX 1
    0 0 0
    Mat_dx
];

%vyrovnan FIX
FIX_vyr = FIX_pribl + Mat_dx(1:5,:);

for i=1:5
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',FIX_name(i,:),FIX_vyr(i,:));
end


%vyrovnan USR
USR_vyr = USR_pribl + Mat_dx(6:7,:);

for i=1:2
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',USR_name(i,:),USR_vyr(i,:));
end



%stredn chyby
fprintf(fid,'--------------------------------------------------------\n');
fprintf(fid,'stredn chyby vyrovnanch bodu\n');
fprintf(fid,'--------------------------------------------------------\n');

Mat_mx = reshape(mx,3,6)';

Mat_mx = [%pridn rdku s nulovmi opravami na pozici FIX 1
    0 0 0
    Mat_mx
];

for i=1:5
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',FIX_name(i,:),Mat_mx(i,:));
end

for i=1:2
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',USR_name(i,:),Mat_mx(i+5,:));
end


fprintf(fid,'\n\naposteriorn m0 = %.4f m (z vyrovnn ste)\n\n\n',m0);

%------------------------------------------------------------
%druh vpocet oprav Vecu dx

lsour2 = [
FIX_vyr(2,x)-FIX_vyr(1,x)
FIX_vyr(3,x)-FIX_vyr(2,x)
FIX_vyr(4,x)-FIX_vyr(3,x)
FIX_vyr(5,x)-FIX_vyr(4,x)
FIX_vyr(1,x)-FIX_vyr(5,x)
USR_vyr(1,x)-FIX_vyr(1,x)
USR_vyr(2,x)-FIX_vyr(1,x)
USR_vyr(1,x)-FIX_vyr(2,x)
USR_vyr(2,x)-FIX_vyr(2,x)
USR_vyr(1,x)-FIX_vyr(3,x)
USR_vyr(2,x)-FIX_vyr(3,x)
USR_vyr(1,x)-FIX_vyr(4,x)
USR_vyr(2,x)-FIX_vyr(4,x)
USR_vyr(1,x)-FIX_vyr(5,x)
USR_vyr(2,x)-FIX_vyr(5,x)
USR_vyr(2,x)-USR_vyr(1,x)

FIX_vyr(2,y)-FIX_vyr(1,y)
FIX_vyr(3,y)-FIX_vyr(2,y)
FIX_vyr(4,y)-FIX_vyr(3,y)
FIX_vyr(5,y)-FIX_vyr(4,y)
FIX_vyr(1,y)-FIX_vyr(5,y)
USR_vyr(1,y)-FIX_vyr(1,y)
USR_vyr(2,y)-FIX_vyr(1,y)
USR_vyr(1,y)-FIX_vyr(2,y)
USR_vyr(2,y)-FIX_vyr(2,y)
USR_vyr(1,y)-FIX_vyr(3,y)
USR_vyr(2,y)-FIX_vyr(3,y)
USR_vyr(1,y)-FIX_vyr(4,y)
USR_vyr(2,y)-FIX_vyr(4,y)
USR_vyr(1,y)-FIX_vyr(5,y)
USR_vyr(2,y)-FIX_vyr(5,y)
USR_vyr(2,y)-USR_vyr(1,y)

FIX_vyr(2,z)-FIX_vyr(1,z)
FIX_vyr(3,z)-FIX_vyr(2,z)
FIX_vyr(4,z)-FIX_vyr(3,z)
FIX_vyr(5,z)-FIX_vyr(4,z)
FIX_vyr(1,z)-FIX_vyr(5,z)
USR_vyr(1,z)-FIX_vyr(1,z)
USR_vyr(2,z)-FIX_vyr(1,z)
USR_vyr(1,z)-FIX_vyr(2,z)
USR_vyr(2,z)-FIX_vyr(2,z)
USR_vyr(1,z)-FIX_vyr(3,z)
USR_vyr(2,z)-FIX_vyr(3,z)
USR_vyr(1,z)-FIX_vyr(4,z)
USR_vyr(2,z)-FIX_vyr(4,z)
USR_vyr(1,z)-FIX_vyr(5,z)
USR_vyr(2,z)-FIX_vyr(5,z)
USR_vyr(2,z)-USR_vyr(1,z)
];

v2 = lsour2-lmer;

v1 = v;%zloha prvnho vpoctu oprav (v bude pozdeji prepsn)

%v1 - v2;%rozdl dvojho vpoctu oprav
%------------------------------------------------------------











%DIFERENCIALNI HELMERT ...



fprintf(fid,'Diferenciln Helmertova transformace\n');
fprintf(fid,'========================================================\n');








T_x_vyr = sum(FIX_vyr(:,1))/5;
T_y_vyr = sum(FIX_vyr(:,2))/5;
T_z_vyr = sum(FIX_vyr(:,3))/5;

T_vyr = [
    T_x_vyr
    T_y_vyr
    T_z_vyr
];


A = [
 1 0 0          0                -(FIX_vyr(1,z)-T_z_vyr)   (FIX_vyr(1,y)-T_y_vyr)  (FIX_vyr(1,x)-T_x_vyr)
 0 1 0   (FIX_vyr(1,z)-T_z_vyr)          0                -(FIX_vyr(1,x)-T_x_vyr)  (FIX_vyr(1,y)-T_y_vyr)
 0 0 1  -(FIX_vyr(1,y)-T_y_vyr)   (FIX_vyr(1,x)-T_x_vyr)          0                (FIX_vyr(1,z)-T_z_vyr)
 
 1 0 0          0                -(FIX_vyr(2,z)-T_z_vyr)   (FIX_vyr(2,y)-T_y_vyr)  (FIX_vyr(2,x)-T_x_vyr)
 0 1 0   (FIX_vyr(2,z)-T_z_vyr)          0                -(FIX_vyr(2,x)-T_x_vyr)  (FIX_vyr(2,y)-T_y_vyr)
 0 0 1  -(FIX_vyr(2,y)-T_y_vyr)   (FIX_vyr(2,x)-T_x_vyr)          0                (FIX_vyr(2,z)-T_z_vyr)

 1 0 0          0                -(FIX_vyr(3,z)-T_z_vyr)   (FIX_vyr(3,y)-T_y_vyr)  (FIX_vyr(3,x)-T_x_vyr)
 0 1 0   (FIX_vyr(3,z)-T_z_vyr)          0                -(FIX_vyr(3,x)-T_x_vyr)  (FIX_vyr(3,y)-T_y_vyr)
 0 0 1  -(FIX_vyr(3,y)-T_y_vyr)   (FIX_vyr(3,x)-T_x_vyr)          0                (FIX_vyr(3,z)-T_z_vyr)

 1 0 0          0                -(FIX_vyr(4,z)-T_z_vyr)   (FIX_vyr(4,y)-T_y_vyr)  (FIX_vyr(4,x)-T_x_vyr)
 0 1 0   (FIX_vyr(4,z)-T_z_vyr)          0                -(FIX_vyr(4,x)-T_x_vyr)  (FIX_vyr(4,y)-T_y_vyr)
 0 0 1  -(FIX_vyr(4,y)-T_y_vyr)   (FIX_vyr(4,x)-T_x_vyr)          0                (FIX_vyr(4,z)-T_z_vyr)

 1 0 0          0                -(FIX_vyr(5,z)-T_z_vyr)   (FIX_vyr(5,y)-T_y_vyr)  (FIX_vyr(5,x)-T_x_vyr)
 0 1 0   (FIX_vyr(5,z)-T_z_vyr)          0                -(FIX_vyr(5,x)-T_x_vyr)  (FIX_vyr(5,y)-T_y_vyr)
 0 0 1  -(FIX_vyr(5,y)-T_y_vyr)   (FIX_vyr(5,x)-T_x_vyr)          0                (FIX_vyr(5,z)-T_z_vyr)
];


T_x = sum(FIX(:,1))/5;
T_y = sum(FIX(:,2))/5;
T_z = sum(FIX(:,3))/5;

T = [
    T_x
    T_y
    T_z
];

%Vec l' (zadan - vyrovnan)
l = [
    (FIX(1,x) - T_x) - (FIX_vyr(1,x) - T_x_vyr)
    (FIX(1,y) - T_y) - (FIX_vyr(1,y) - T_y_vyr)
    (FIX(1,z) - T_z) - (FIX_vyr(1,z) - T_z_vyr)

    (FIX(2,x) - T_x) - (FIX_vyr(2,x) - T_x_vyr)
    (FIX(2,y) - T_y) - (FIX_vyr(2,y) - T_y_vyr)
    (FIX(2,z) - T_z) - (FIX_vyr(2,z) - T_z_vyr)

    (FIX(3,x) - T_x) - (FIX_vyr(3,x) - T_x_vyr)
    (FIX(3,y) - T_y) - (FIX_vyr(3,y) - T_y_vyr)
    (FIX(3,z) - T_z) - (FIX_vyr(3,z) - T_z_vyr)

    (FIX(4,x) - T_x) - (FIX_vyr(4,x) - T_x_vyr)
    (FIX(4,y) - T_y) - (FIX_vyr(4,y) - T_y_vyr)
    (FIX(4,z) - T_z) - (FIX_vyr(4,z) - T_z_vyr)

    (FIX(5,x) - T_x) - (FIX_vyr(5,x) - T_x_vyr)
    (FIX(5,y) - T_y) - (FIX_vyr(5,y) - T_y_vyr)
    (FIX(5,z) - T_z) - (FIX_vyr(5,z) - T_z_vyr)
];
%------------------------------------------
%parametry Mat rotace
fi = FIX_fl(1,2);
b = (fi-90)/ro;

Ry = [
    cos(b) 0 -sin(b)
      0    1    0
    sin(b) 0  cos(b)
];
    
%--
lamda = FIX_fl(1,3);
g = -lamda/ro;

Rz = [
     cos(g) sin(g)   0
    -sin(g) cos(g)   0
       0      0      1
];
%------------------------------------------
H = Rz*Ry;%Mat rotace natocen strednch chyb z S-JTSK na Bessel
%------------------------------------------
% 
% stredn chyby bodu
%Poznmka: stredn chyby presnch vec stac zvolit dostatecne mal
%          a stredn chyby nepresnch vec dostatecne velk. Prijt
%          na to mi trvalo asi tden a hodne (zbytecnho) programovn ...

mx1 = 0.001;
my1 = 0.001;
mz1 = 0.001;

mx2 = 0.001;
my2 = 0.001;
mz2 = 5;

mx3 = 500;
my3 = 500;
mz3 = 0.001;

mx4 = 0.001;
my4 = 0.001;
mz4 = 5;

mx5 = 0.001;
my5 = 0.001;
mz5 = 0.001;

%--------------------------------------------------------------------------------------------
% %tady zacn cern magie
%--------------------------------------------------------------------------------------------
% 
 Q1 = H * diag([mx1^2,my1^2,mz1^2]) * H';
 Q2 = H * diag([mx2^2,my2^2,mz2^2]) * H';
 Q3 = H * diag([mx3^2,my3^2,mz3^2]) * H';
 Q4 = H * diag([mx4^2,my4^2,mz4^2]) * H';
 Q5 = H * diag([mx5^2,my5^2,mz5^2]) * H';
% 
ZZ = zeros(3);
QQ = eye(3);

Q = [
Q1 ZZ ZZ ZZ ZZ
ZZ Q2 ZZ ZZ ZZ
ZZ ZZ Q3 ZZ ZZ
ZZ ZZ ZZ Q4 ZZ
ZZ ZZ ZZ ZZ Q5
];

%--------------------------------------------
P = inv(Q);
%P = eye(15); %jednotkov Mat vah

%vyrovnn
N = A' * P * A;
dx = inv(N) * A' * P * l;
v = A * dx - l;


v_Mat = reshape(v,3,5)';

%--------------------------------------------------------------------------------------------
%konec cern magie
%--------------------------------------------------------------------------------------------

%vyrovnan transformacn koeficienty
Tx = dx(1);
Ty = dx(2);
Tz = dx(3);
alfa = dx(4);
beta = dx(5);
gama = dx(6);
m = dx(7);

alfav = ro * alfa * 3600;%prevod na ''
betav = ro * beta * 3600;
gamav = ro * gama * 3600;

%stredn chyby

%aposteriorn stredn chyba jednotkov
m0 = ((v'*v)/(15-7))^0.5;

%obecne stredni chyby souradnic
mX = (sum(v_Mat(:,1) .* v_Mat(:,1)) / 5)^0.5;
mY = (sum(v_Mat(:,2) .* v_Mat(:,2)) / 5)^0.5;
mZ = (sum(v_Mat(:,3) .* v_Mat(:,3)) / 5)^0.5;
mXYZ = ((mX^2 + mY^2 + mZ^2)/3)^0.5;
mV = (mX^2 + mY^2 + mZ^2)^0.5; %mira ztotoznen


%str.ch.neznmch (trns.parametru)
Mx = m0 * diag(inv(N)).^0.5;

%str.ch.zpr (ID bodu)
Ml = m0 * diag(A*inv(N)*A').^0.5;
Ml_Mat = 1000 * reshape(Ml,3,5)';


%-----------------------------------

fprintf(fid,'\nCharakteristiky presnosti\n');
fprintf(fid,'---------------------------\n');


fprintf(fid,'   m0 = %3.1f mm (aposteriorn)\n\n',1000*m0);


fprintf(fid,'   mX = %3.1f mm\n',1000*mX);
fprintf(fid,'   mY = %3.1f mm\n',1000*mY);
fprintf(fid,'   mZ = %3.1f mm\n',1000*mZ);
fprintf(fid,' mXYZ = %3.1f mm\n',1000*mXYZ);
fprintf(fid,'   mV = %3.1f mm\n\n',1000*mV);

fprintf(fid,'Vyrovnane transformacni koeficienty a jejich stredni chyby\n');
fprintf(fid,'----------------------------------------------------------\n');
fprintf(fid,'  Tx = %8.5f m  \t   mTx = %3.2f mm   (teziste je redukovan)\n',Tx,1000*Mx(1));
fprintf(fid,'  Ty = %8.5f m  \t   mTy = %3.2f mm\n',Ty,1000*Mx(2));
fprintf(fid,'  Tz = %8.5f m  \t   mTz = %3.2f mm\n',Tz,1000*Mx(3));
fprintf(fid,'   m = %8.12f  mq = %2.9f\n',m,Mx(7));
fprintf(fid,'alfa = %7.4f'''' \t malfa = %2.3f''''\n',alfav,3600*ro*Mx(4));
fprintf(fid,'beta = %7.4f'''' \t mbeta = %2.3f''''\n',betav,3600*ro*Mx(5));
fprintf(fid,'gama = %7.4f'''' \t mgama = %2.3f''''\n',gamav,3600*ro*Mx(6));

%-----------------------------------


%transformace

R = [
       1   gama  -beta
    -gama    1    alfa
     beta -alfa     1
 ];
 
 
%transformace identickch bodu (FIX)
 for i=1:5
     pom = (1 + m) * R * FIX_vyr(i,:)' + [Tx,Ty,Tz]' + T - (1 + m) * R * T_vyr;
     FIX_trns(i,1) = pom(1);
     FIX_trns(i,2) = pom(2);
     FIX_trns(i,3) = pom(3);
 end
 
 

%  fprintf(fid,'\n');
%  for i=1:5
%      fprintf(fid,' \t %+10.5f  %+10.5f  %+10.5f\n',v_Mat(i,:));
%  end
 


%transformace podrobnch bodu (USR)
  for i=1:2
     pom = (1 + m) * R * USR_vyr(i,:)' + [Tx,Ty,Tz]' + T - (1 + m) * R * T_vyr;
     USR_trns(i,1) = pom(1);
     USR_trns(i,2) = pom(2);
     USR_trns(i,3) = pom(3);
 end


 


fprintf(fid,'\n\n\n========================================================\n');
fprintf(fid,'Transformovan body (Bessel/WGS-84 II)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'  bod           X [m]          Y [m]          Z [m]\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');


for i=1:5
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',FIX_name(i,:),FIX_trns(i,:));
end

for i=1:2
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',USR_name(i,:),USR_trns(i,:));
end

fprintf(fid,'=================================================================================\n');
fprintf(fid,'opravy identickch bodu (FIX1 az 5)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'  bod          oX [m]         oY [m]         oZ [m]\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');

for i=1:5
    fprintf(fid,'  %s \t %10.4f \t %10.4f \t %10.4f\n',FIX_name(i,:),v_Mat(i,:));
end

fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'stredn chyby identickch bodu (FIX1 az 5)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'  bod          mX [mm]        mY [mm]        mZ [mm]\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');

for i=1:5
    fprintf(fid,'  %s \t %10.2f \t %10.2f \t %10.2f\n',FIX_name(i,:),Ml_Mat(i,:));
end

fprintf(fid,'=================================================================================\n');



%prevod Bessel II na zemepisne II
fprintf(fid,'zemepisn souradnice na Besselove elipsoidu\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'  bod            fi                     lamda                H (elipsoidick)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');

for i=1:5
    [f,l,Hel] = XYZ2flH(FIX_trns(i,1),FIX_trns(i,2),FIX_trns(i,3),1);
    FIX_flH2(i,1) = FIX_JTSK(i,1); %cislo
    FIX_flH2(i,2) = f;             %fi
    FIX_flH2(i,3) = l;             %lamda
    FIX_flH2(i,4) = Hel;           %vyska (elipsoidicka)

    fprintf(fid,'  FIX%.f \t %4.f %2.f'' %8.5f'''' \t %4.f %2.f'' %8.5f'''' \t %4.4f\n',i,dms2mat(deg2dms(f)),dms2mat(deg2dms(l)),Hel);
end

for i=1:2
    [f,l,Hel] = XYZ2flH(USR_trns(i,1),USR_trns(i,2),USR_trns(i,3),1);
    USR_flH2(i,1) = 4000 + i;      %cislo
    USR_flH2(i,2) = f;             %fi
    USR_flH2(i,3) = l;             %lamda
    USR_flH2(i,4) = Hel;           %vyska (elipsoidicka)

    fprintf(fid,'  USR%.f \t %4.f %2.f'' %8.5f'''' \t %4.f %2.f'' %8.5f'''' \t %4.4f\n',i,dms2mat(deg2dms(f)),dms2mat(deg2dms(l)),Hel);
end


%prevod zemepisnych II na S-JTSK II
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'S-JTSK II\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'  bod        X [m]         Y [m]      H [m] (elipsoidick)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');

for i=1:5
    [y,x] = fl2JTSK(FIX_flH2(i,2),FIX_flH2(i,3));
    FIX_JTSK2(i,1) = FIX_JTSK(i,1); %cislo
    FIX_JTSK2(i,2) = x;             %x
    FIX_JTSK2(i,3) = y;             %y
    FIX_JTSK2(i,4) = FIX_flH2(i,4); %vyska (elipsoidicka)
    
    fprintf(fid,'  FIX%.f   %11.4f   %11.4f   %4.4f\n',FIX_JTSK2(i,:));
end

for i=1:2
    [y,x] = fl2JTSK(USR_flH2(i,2),USR_flH2(i,3));
    USR_JTSK2(i,1) = 4000 + i;      %cislo
    USR_JTSK2(i,2) = x;             %x
    USR_JTSK2(i,3) = y;             %y
    USR_JTSK2(i,4) = USR_flH2(i,4); %vyska (elipsoidicka)
    
    fprintf(fid,'  USR%.f   %6.4f   %6.4f   %4.4f\n',i,USR_JTSK2(i,2:4));
end
fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'opravy identickch bodu\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');
opr = FIX_JTSK(:,2:4) - FIX_JTSK2(:,2:4);
for i=1:5
    fprintf(fid,'  FIX%.f   %+11.4f   %+11.4f   %+4.4f\n',i,opr(i,:));
end




%----------------------------------------------------------------------------------------------




%JUNGOVA DOTRANSFORMACE ...




fprintf(fid,'---------------------------------------------------------------------------------\n');
fprintf(fid,'S-JTSK (S-JTSK II po Jungove dotransformaci)\n');
fprintf(fid,'---------------------------------------------------------------------------------\n');

ID = [%puvodn ID body
    FixJTSK(1,2:3)
    FixJTSK(2,2:3)
    FixJTSK(4,2:3)
    FixJTSK(5,2:3)
];

ID2 = [%pretransformovan  ID body
    FIX_JTSK2(1,2:3)
    FIX_JTSK2(2,2:3)
    FIX_JTSK2(4,2:3)
    FIX_JTSK2(5,2:3)
];

DID = ID - ID2;%rozdl ID bodu (puvodn - transformovan)

Dx = DID(:,1);%Delta Xi
Dy = DID(:,2);%Delta Yi

body = [%body pro Junga
    FIX_JTSK2(:,2:3)
    USR_JTSK2(:,2:3)
];

%JUNG
for j=1:7
    Sp = 0;
    Spx = 0;
    Spy = 0;
    for i=1:4
        p = 1/delka2D(body(j,2),body(j,1),ID(i,2),ID(i,1));%1/dlky na ID body
        Spx = Spx + Dx(i) * p;
        Spy = Spy + Dy(i) * p;
        Sp = Sp + p;
    end
    ox(j,1) = Spx / Sp;
    oy(j,1) = Spy / Sp;    
end

JTSK_Jung = [body(:,1) + ox , body(:,2) + oy];

%FixJTSK(:,2:3)

for i=1:5
    fprintf(fid,'  FIX%.f   %11.4f   %11.4f   %4.4f\n',i,JTSK_Jung(i,:),FIX_JTSK2(i,4));
end

for i=1:2
    fprintf(fid,'  USR%.f   %11.4f   %11.4f   %4.4f\n',i,JTSK_Jung(i+5,:),USR_JTSK2(i,4));
end




fclose(fid);
fprintf('\n\nCseln vsledky jsou ulozeny v souboru "3.txt"\n v pracovnm adresri\n\n');